<?php

namespace App\Service\SnipParser;

use App\Service\SnipParser\Stages\HtmlEscapeStage;
use App\Service\SnipParser\Stages\ReplaceBlocksStage;
use League\Pipeline\PipelineBuilder;

class Pipeline
{
    public function parse(string $payload): string
    {
        $builder = new PipelineBuilder();
        $pipeline = $builder
            ->add(new HtmlEscapeStage())
            ->add(new ReplaceBlocksStage('<pre><code>', '</code></pre>', '```'))
            ->build();

        return $pipeline->process($payload);
    }
}